/*
 * Copyright 2009 Cedric Priscal
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package android_serialport_api;

import android.util.Log;

import java.io.File;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class SerialPort {

    private static final String TAG = "SerialPort";

    /*
     * Do not remove or rename the field mFd: it is used by native method close();
     */
    private FileDescriptor mFd;
    private FileInputStream mFileInputStream;
    private FileOutputStream mFileOutputStream;

    public SerialPort(File device, int baudrate, int flags) throws SecurityException, IOException {
        /* Check access permission */
        Log.d(TAG, "[SerialPort] device.canRead [" + device.canRead() + "] device.canWrite [" + device.canWrite() + "]");
        if (!device.canRead() || !device.canWrite()) {
            try {
                Log.i(TAG, "[SerialPort] (" + device.getPath() + ")  access permission Change !!! START ...");
                Process su = Runtime.getRuntime().exec("/system/bin/su"); // 원래 로비폰 코드
//                Process su = Runtime.getRuntime().exec("su"); // 월패드 통화 코드
//                Process su = Runtime.getRuntime().exec(new String[] {"su", "-c", "reboot"});
//                Process su = Runtime.getRuntime().exec("/system/xbin/su");
                String cmd = "chmod 666 " + device.getAbsolutePath() + "\n" + "exit\n";
                su.getOutputStream().write(cmd.getBytes());
                su.getOutputStream().flush();
                su.getErrorStream().close();
                su.getInputStream().close();
                su.getOutputStream().close();
                su.waitFor();

                boolean bCanRead = device.canRead();
                boolean bCanWrite = device.canWrite();
                if (!bCanRead || !bCanWrite) {
                    Log.e(TAG, "[SerialPort] access permission Change Error !!! (bCanRead [" + bCanRead + "], bCanWrite [" + bCanWrite + "])");
                    throw new SecurityException();
                }
            } catch (Exception e) {
                Log.e(TAG, "[Exception] SerialPort()");
                e.printStackTrace();
                throw new SecurityException();
            }
        }

        mFd = open(device.getAbsolutePath(), baudrate, flags);
        if (mFd == null) {
            Log.e(TAG, "native open returns null");
            throw new IOException();
        }
        mFileInputStream = new FileInputStream(mFd);
        mFileOutputStream = new FileOutputStream(mFd);
    }

    // Getters and setters
    public InputStream getInputStream() {
        return mFileInputStream;
    }

    public OutputStream getOutputStream() {
        return mFileOutputStream;
    }

    public FileDescriptor get_FD() {
        return mFd;
    }

    // JNI
    private native static FileDescriptor open(String path, int baudrate, int flags);

    public native void close();

    static {
        System.loadLibrary("serial_port");
    }
}
